Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj	(revision 5539)
@@ -0,0 +1,247 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project DefaultTargets="Build" ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <ItemGroup Label="ProjectConfigurations">
+    <ProjectConfiguration Include="Debug|ARM">
+      <Configuration>Debug</Configuration>
+      <Platform>ARM</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Debug|Win32">
+      <Configuration>Debug</Configuration>
+      <Platform>Win32</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Debug|x64">
+      <Configuration>Debug</Configuration>
+      <Platform>x64</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Release|ARM">
+      <Configuration>Release</Configuration>
+      <Platform>ARM</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Release|Win32">
+      <Configuration>Release</Configuration>
+      <Platform>Win32</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Release|x64">
+      <Configuration>Release</Configuration>
+      <Platform>x64</Platform>
+    </ProjectConfiguration>
+  </ItemGroup>
+  <ItemGroup Condition="'$(API_Family)'=='UWP'">
+    <ClCompile Include="VoipHost.cpp" />
+  </ItemGroup>
+  <ItemGroup>
+    <AppxManifest Include="..\voip\package.appxmanifest">
+      <SubType>Designer</SubType>
+    </AppxManifest>
+  </ItemGroup>
+  <PropertyGroup Label="Globals">
+    <ProjectGuid>{016d497f-0ee0-449e-89f5-bd63f7f9a8a6}</ProjectGuid>
+    <Keyword>WindowsRuntimeComponent</Keyword>
+    <ProjectName>VoipHost</ProjectName>
+    <RootNamespace>VoipHost</RootNamespace>
+    <DefaultLanguage>en-US</DefaultLanguage>
+    <MinimumVisualStudioVersion>14.0</MinimumVisualStudioVersion>
+    <AppContainerApplication>true</AppContainerApplication>
+    <ApplicationType>Windows Store</ApplicationType>
+    <WindowsTargetPlatformVersion>10.0.10586.0</WindowsTargetPlatformVersion>
+    <WindowsTargetPlatformMinVersion>10.0.10240.0</WindowsTargetPlatformMinVersion>
+    <ApplicationTypeRevision>10.0</ApplicationTypeRevision>
+  </PropertyGroup>
+  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'" Label="Configuration">
+    <ConfigurationType>Application</ConfigurationType>
+    <UseDebugLibraries>true</UseDebugLibraries>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'" Label="Configuration">
+    <ConfigurationType>Application</ConfigurationType>
+    <UseDebugLibraries>true</UseDebugLibraries>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|x64'" Label="Configuration">
+    <ConfigurationType>Application</ConfigurationType>
+    <UseDebugLibraries>true</UseDebugLibraries>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'" Label="Configuration">
+    <ConfigurationType>Application</ConfigurationType>
+    <UseDebugLibraries>false</UseDebugLibraries>
+    <WholeProgramOptimization>true</WholeProgramOptimization>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|ARM'" Label="Configuration">
+    <ConfigurationType>Application</ConfigurationType>
+    <UseDebugLibraries>false</UseDebugLibraries>
+    <WholeProgramOptimization>true</WholeProgramOptimization>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|x64'" Label="Configuration">
+    <ConfigurationType>Application</ConfigurationType>
+    <UseDebugLibraries>false</UseDebugLibraries>
+    <WholeProgramOptimization>true</WholeProgramOptimization>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <!-- Import common config -->
+  <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-config.props" />
+  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-arm-common-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win32-common-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-arm-common-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win32-common-defaults.props" />
+  </ImportGroup>
+  <PropertyGroup>
+    <TargetName>$(ProjectName)</TargetName>
+    <IntDir>.\output\$(ProjectName)\</IntDir>
+    <OutDir>..\bin\</OutDir>
+  </PropertyGroup>
+  <ImportGroup Label="ExtensionSettings">
+  </ImportGroup>
+  <ImportGroup Label="Shared">
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <PropertyGroup Label="UserMacros" />
+  <PropertyGroup />
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
+      <CompileAsWinRT>true</CompileAsWinRT>
+    </ClCompile>
+    <Link>
+      <SubSystem>Windows</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+      <OutputFile>..\bin\$(ProjectName)$(TargetExt)</OutputFile>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+    </ClCompile>
+    <Link>
+      <SubSystem>Windows</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
+      <CompileAsWinRT>true</CompileAsWinRT>
+    </ClCompile>
+    <Link>
+      <SubSystem>Windows</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+      <OutputFile>..\bin\$(ProjectName)$(TargetExt)</OutputFile>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+    </ClCompile>
+    <Link>
+      <SubSystem>Windows</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+    </ClCompile>
+    <Link>
+      <SubSystem>Windows</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+    </ClCompile>
+    <Link>
+      <SubSystem>Windows</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <!--Don't build this project unless it's for UWP-->
+  <Import Condition="'$(API_Family)'=='UWP'" Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <Import Condition="'$(API_Family)'!='UWP'" Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-build-targets.targets" />
+  <ImportGroup Label="ExtensionTargets">
+  </ImportGroup>
+</Project>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj.filters
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj.filters	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.vcxproj.filters	(revision 5539)
@@ -0,0 +1,15 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <ItemGroup>
+    <Filter Include="Resources">
+      <UniqueIdentifier>bfd33be3-f275-42ab-98e7-d1430685d099</UniqueIdentifier>
+      <Extensions>rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx;tga;tiff;tif;png;wav;mfcribbon-ms</Extensions>
+    </Filter>
+  </ItemGroup>
+  <ItemGroup>
+    <ClCompile Include="VoipHost.cpp" />
+  </ItemGroup>
+  <ItemGroup>
+    <AppxManifest Include="..\voip\package.appxmanifest" />
+  </ItemGroup>
+</Project>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/AppService.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/AppService.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/AppService.cs	(revision 5539)
@@ -0,0 +1,152 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using System;
+using VoipTasks.BackgroundOperations;
+using VoipTasks.Helpers;
+using Windows.ApplicationModel.AppService;
+using Windows.ApplicationModel.Background;
+using Windows.ApplicationModel.Calls;
+using Windows.Foundation.Collections;
+using VoipBackEnd;
+
+namespace VoipTasks
+{
+    public sealed class AppService : IBackgroundTask
+    {
+        AppServiceConnection _connection;
+        BackgroundTaskDeferral _deferral;
+
+        public void Run(IBackgroundTaskInstance taskInstance)
+        {
+            AppServiceTriggerDetails triggerDetail = taskInstance.TriggerDetails as AppServiceTriggerDetails;
+            _deferral = taskInstance.GetDeferral();
+
+            // Register for Task Cancel callback
+            taskInstance.Canceled += TaskInstance_Canceled;
+
+            AppServiceConnection connection = triggerDetail.AppServiceConnection;
+            _connection = connection;
+
+            connection.RequestReceived += Connection_RequestReceived;
+            Current.AppConnection = connection;
+        }
+
+        private async void Connection_RequestReceived(AppServiceConnection sender, AppServiceRequestReceivedEventArgs args)
+        {
+            var deferral = args.GetDeferral();
+            var response = new ValueSet();
+            bool stop = false;
+            try
+            {
+                var request = args.Request;
+                var message = request.Message;
+                if (message.ContainsKey(BackgroundOperation.NewBackgroundRequest))
+                {
+                    switch ((BackgroundRequest)message[BackgroundOperation.NewBackgroundRequest])
+                    {
+                        case BackgroundRequest.NewOutgoingCall:
+                            Current.AppRequest = args.Request;
+                            Current.Request = BackgroundRequest.NewOutgoingCall;
+                            Current.AppRequestDeferal = deferral;
+                            await Current.RequestNewCallAsync(message[NewCallArguments.DstURI.ToString()] as String);
+                            break;
+
+                        case BackgroundRequest.EndCall:
+                            Current.AppRequest = args.Request;
+                            Current.Request = BackgroundRequest.EndCall;
+                            Current.AppRequestDeferal = deferral;
+                            Current.EndCallAsync();
+                            break;
+
+                        case BackgroundRequest.StartService:
+                            Current.AppRequest = args.Request;
+                            Current.Request = BackgroundRequest.StartService;
+                            Current.AppRequestDeferal = deferral;
+                            Current.StartService();                            
+
+                            break;
+                        case BackgroundRequest.StopService:
+                            Current.AppRequest = args.Request;
+                            Current.Request = BackgroundRequest.StopService;
+                            Current.AppRequestDeferal = deferral;
+                            Current.StopService();
+                            break;
+
+                        case BackgroundRequest.GetAccountInfo:
+                            Current.AppRequest = args.Request;
+                            Current.Request = BackgroundRequest.GetAccountInfo;
+                            Current.AppRequestDeferal = deferral;
+
+                            Current.GetAccountInfo();
+                            break;
+
+                        case BackgroundRequest.ModifyAccount:
+                            Current.AppRequest = args.Request;
+                            Current.Request = BackgroundRequest.ModifyAccount;
+                            Current.AppRequestDeferal = deferral;
+                            Current.ModifyAccount(message[ModifyAccountArguments.id.ToString()] as String,
+                                    message[ModifyAccountArguments.registrar.ToString()] as String,
+                                    message[ModifyAccountArguments.proxy.ToString()] as String,
+                                    message[ModifyAccountArguments.username.ToString()] as String,
+                                    message[ModifyAccountArguments.password.ToString()] as String);
+
+                            break;
+
+                        default:
+                            stop = true;
+                            break;
+                    }
+                }
+            }
+            finally
+            {
+               
+                if (stop)
+                {
+                    _deferral.Complete();
+                }
+            }
+        }
+
+        private void TaskInstance_Canceled(IBackgroundTaskInstance sender, BackgroundTaskCancellationReason reason)
+        {
+            if (_deferral != null)
+            {
+                _deferral.Complete();
+            }
+        }
+
+        private static void Call_ResumeRequested(VoipPhoneCall sender, CallStateChangeEventArgs args)
+        {
+            sender.NotifyCallActive();
+        }
+
+        private static void Call_RejectRequested(VoipPhoneCall sender, CallRejectEventArgs args)
+        {
+            sender.NotifyCallEnded();
+        }
+
+        private static void Call_HoldRequested(VoipPhoneCall sender, CallStateChangeEventArgs args)
+        {
+            sender.NotifyCallHeld();
+        }
+
+        private static void Call_EndRequested(VoipPhoneCall sender, CallStateChangeEventArgs args)
+        {
+            sender.NotifyCallEnded();
+        }
+
+        private static void Call_AnswerRequested(VoipPhoneCall sender, CallAnswerEventArgs args)
+        {
+            sender.NotifyCallActive();
+        }
+    }
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/BackgroundOperations/BackgroundOperations.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/BackgroundOperations/BackgroundOperations.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/BackgroundOperations/BackgroundOperations.cs	(revision 5539)
@@ -0,0 +1,112 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using System;
+
+namespace VoipTasks.BackgroundOperations
+{
+    public enum BackgroundRequest
+    {        
+        NewOutgoingCall,
+        EndCall,
+        GetCallDuration,
+        StartVideo,
+        EndVideo,
+
+        //Account request
+        GetAccountInfo,
+        ModifyAccount,
+
+        //Endpoint request
+        StartService,
+        StopService,
+
+        // Always keep this as the last option
+        InValid
+    }
+
+    public enum ForegroundReguest
+    {
+        UpdateCallState,
+        UpdateAcccountInfo,
+        UpdateRegState,
+        InValid
+    }
+
+    public enum NewCallArguments
+    {
+        DstURI
+    }
+
+    public enum ModifyAccountArguments
+    {
+        id,
+        registrar,
+        proxy,
+        username,
+        password
+    }
+
+    public enum UpdateCallStateArguments
+    {
+        CallState
+    }
+
+    public enum UpdateRegStateArguments
+    {
+        RegState
+    }
+
+    public enum UpdateAccountInfoArguments
+    {
+        id,
+        registrar,
+        proxy,
+        username,
+        password
+    }
+
+    public enum OperationResult
+    {
+        Succeeded,
+        Failed
+    }
+
+    public static class BackgroundOperation
+    {
+        public static String AppServiceName
+        {
+            get { return _appServiceName; }
+        }
+
+        public static String NewBackgroundRequest
+        {
+            get { return _newBackgroundRequest; }
+        }
+
+        public static String Result
+        {
+            get { return _result; }
+        }
+
+        const String _appServiceName = "VoipTasks.AppService";
+        const String _newBackgroundRequest = "NewBackgroundRequest";
+        const String _result = "Result";
+    }
+
+    public static class ForegroundOperation
+    {
+        public static String NewForegroundRequest
+        {
+            get { return _newForegroundRequest; }
+        }
+        const String _newForegroundRequest = "NewForegroundRequest";
+    }
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/CallRtcTask.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/CallRtcTask.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipTasks/CallRtcTask.cs	(revision 5539)
@@ -0,0 +1,39 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using VoipTasks.Helpers;
+using Windows.ApplicationModel.Background;
+
+namespace VoipTasks
+{
+    public sealed class CallRtcTask : IBackgroundTask
+    {
+        BackgroundTaskDeferral _deferral;
+
+        public void Run(IBackgroundTaskInstance taskInstance)
+        {
+            _deferral = taskInstance.GetDeferral();
+
+            Current.RTCTaskDeferral = _deferral;
+            // Register for Task Cancel callback
+            taskInstance.Canceled += TaskInstance_Canceled;            
+        }
+
+        private void TaskInstance_Canceled(IBackgroundTaskInstance sender, BackgroundTaskCancellationReason reason)
+        {
+            if (_deferral != null)
+            {
+                _deferral.Complete();
+            }
+
+            Current.RTCTaskDeferral = null;
+        }
+    }
+}
